' Library     Access database,   ADO.NET . 
'   Light   ADO NET Data Control    .
' :  
' : Freeware.      Windows  . 
' : mouratx@yahoo.com  ,   http://users.att.sch.gr/mouratx
'      .          .

'Version 1.2

Imports System.ComponentModel
Imports System.Data.OleDb

<AttributeUsage(AttributeTargets.All)> _
Public Class clsDataManager

    '  ADO.NET     .
    Public objConnection As OleDbConnection
    Public objDataAdapter As OleDbDataAdapter
    Public objCommBuilder As OleDbCommandBuilder
    Public objDataSet As DataSet
    Public objDataView As DataView

    '       RsFind (). 
    '        ( string )
    Public Enum FindTypeForStringEnum
        Equal = 1             ' 
        StartsWith = 2        '  
        EndsWith = 3          '  
        Contains = 4          ' 
    End Enum

    '    
    Private _ErrorMsg$   '   .

    '        
    Private _AllowAdd As Boolean     '   ;
    Private _AllowEdit As Boolean    '   ;
    Private _AllowDelete As Boolean  '   ;
    Private _SortText$    'To string      (read-only).
    Private _FilterText$  'To string      (read-only).
    Private _FindTypeForString As FindTypeForStringEnum '   string.
    Private _MatchCaseForString As Boolean '  .  -;

    '   .
    Public Event OnDataError(ByVal ErrorMsg$)
    '-------------------------------------------------------------------------------------------------
    '-------------------------------------------------------------------------------------------------
    'PUBLIC 
    '-------------------------------------------------------------------------------------------------
    '--------------------------------------------------
    <Category("Data"), Description("      ")> _
    Public Property AllowAdd() As Boolean
        Get
            Return _AllowAdd
        End Get
        Set(ByVal Value As Boolean)
            If _AllowAdd <> Value Then
                _AllowAdd = Value
            End If
        End Set
    End Property
    '--------------------------------------------------
    <Category("Data"), Description("      ")> _
    Public Property AllowEdit() As Boolean
        Get
            Return _AllowEdit
        End Get
        Set(ByVal Value As Boolean)
            If _AllowEdit <> Value Then
                _AllowEdit = Value
            End If
        End Set
    End Property
    '--------------------------------------------------
    <Category("Data"), Description("      ")> _
    Public Property AllowDelete() As Boolean
        Get
            Return _AllowDelete
        End Get
        Set(ByVal Value As Boolean)
            If _AllowDelete <> Value Then
                _AllowDelete = Value
            End If
        End Set
    End Property
    '--------------------------------------------------
    <Description("   Sort,     RsSort"), Browsable(False), _
   EditorBrowsable(EditorBrowsableState.Always)> _
   Public ReadOnly Property SortText$()
        Get
            Return _SortText
        End Get
    End Property
    '--------------------------------------------------
    <Description("   Filter,     RsFilter"), Browsable(False), _
    EditorBrowsable(EditorBrowsableState.Always)> _
    Public ReadOnly Property FilterText$()
        Get
            Return _FilterText
        End Get
    End Property
    '--------------------------------------------------
    '--------------------------------------------------
    <Description("O  ,    RsFind"), Browsable(False), _
    EditorBrowsable(EditorBrowsableState.Always)> _
    Public Property FindTypeForString() As FindTypeForStringEnum
        Get
            Return _FindTypeForString
        End Get
        Set(ByVal value As FindTypeForStringEnum)
            _FindTypeForString = value
        End Set
    End Property
    '--------------------------------------------------
    <Description(" /,    RsFind"), Browsable(False), _
    EditorBrowsable(EditorBrowsableState.Always)> _
    Public Property MatchCaseForString() As Boolean
        Get
            Return _MatchCaseForString
        End Get
        Set(ByVal value As Boolean)
            _MatchCaseForString = value
        End Set
    End Property
    '--------------------------------------------------
    <Category("Data"), Description("      "), Browsable(False), _
        EditorBrowsable(EditorBrowsableState.Always)> _
        Public ReadOnly Property ConnectionString() As String
        Get
            If Not (objConnection Is Nothing) Then Return objConnection.ConnectionString Else Return ""
        End Get
    End Property
    '---------------------------------------------------------------------------------
    <Category("Data"), Description("    (, , )  Dataset"), Browsable(False), _
    EditorBrowsable(EditorBrowsableState.Always)> _
    Public ReadOnly Property HasChanges() As Boolean
        Get
            If Not (objDataSet Is Nothing) Then Return objDataSet.HasChanges
        End Get
    End Property
    '--------------------------------------------------------------------------------
    '---------------------------------------------------------------------------------
    ' PUBLIC ME
    '---------------------------------------------------------------------------------
    'Constructor instance.
    Public Sub New()

        Try
            '    ADO.NET
            objConnection = New OleDbConnection()
            objDataAdapter = New OleDbDataAdapter()
            objCommBuilder = New OleDbCommandBuilder()
            objDataSet = New DataSet()
            objDataView = New DataView()

            _AllowAdd = True : _AllowEdit = True : _AllowDelete = True
            _FilterText = "" : _SortText = "" : _FindTypeForString = FindTypeForStringEnum.StartsWith
            _MatchCaseForString = True

        Catch e As Exception
            _ErrorMsg = "    object instance" & vbCrLf & vbCrLf & e.Message
            RaiseEvent OnDataError(_ErrorMsg)
        End Try

    End Sub
    '---------------------------------------------------------------------------------
    '     .
    '   RecordSet  DataView         recordset.
    Public Function Open(ByVal strConnectionString As String, ByVal strSelectCommand As String, ByVal CommandType As CommandType) As Boolean
        Try
            ',    
            '.
            If Not (objConnection Is Nothing) Then
                objConnection.Close()
            End If

            '  data objects:
            'objConnection, objDataAdapter .
            ReleaseDataObjects()

            '      .
            objConnection = New OleDbConnection(strConnectionString)
            objConnection.Open()

            '  select command.
            objDataAdapter = New OleDbDataAdapter()
            With objDataAdapter
                .SelectCommand = New OleDbCommand()
                .SelectCommand.Connection = objConnection
                .SelectCommand.CommandType = CommandType
                .SelectCommand.CommandText = strSelectCommand
            End With

            'B  recordset   Dataset.
            objDataSet = New DataSet()
            objDataAdapter.Fill(objDataSet, "Recordset")

            ' ,    
            ' CommandBuilder.
            objCommBuilder = New OleDbCommandBuilder(objDataAdapter)
            objCommBuilder.RefreshSchema()

            '  objDataView
            If Not MakeDataView() Then Return False

            ' .
            Return True

        Catch e As Exception
            _ErrorMsg = "        ." & vbCrLf & vbCrLf & e.Message
            RaiseEvent OnDataError(_ErrorMsg)
            ' .
            Return False
        End Try

    End Function
    '--------------------------------------------------
    '  .
    Public Function Close() As Boolean
        Try
            ',    .
            If Not (objConnection Is Nothing) Then
                objConnection.Close()
            End If
            ReleaseDataObjects()
            Return True
        Catch e As Exception
            _ErrorMsg = "        ." & vbCrLf & vbCrLf & e.Message
            RaiseEvent OnDataError(_ErrorMsg)
            Return False
        End Try

    End Function
    '--------------------------------------------------
    '     .
    Public Function RsCount() As Integer
        Try
            Return objDataView.Count
        Catch
            Return 0
        End Try

    End Function
    '--------------------------------------------------
    '   Recordset  .
    Public Function RsEmpty() As Boolean
        Try
            If objDataView.Count > 0 Then Return False Else Return True

        Catch e As Exception
            _ErrorMsg = "     " & vbCrLf & vbCrLf & e.Message
            RaiseEvent OnDataError(_ErrorMsg)
        End Try

    End Function
    '----------------------------------------------------
    ' to Dataset      .
    Public Sub RsRefresh()

        Try
            objDataSet.Clear()
            objDataAdapter.Fill(objDataSet, "Recordset")

            If Not (objDataView Is Nothing) Then objDataView = Nothing

            '  objDataView
            MakeDataView()

        Catch e As Exception
            _ErrorMsg = "       ." & vbCrLf & vbCrLf & e.Message
            RaiseEvent OnDataError(_ErrorMsg)
        End Try

    End Sub
    '----------------------------------------------------------------------------------
    '      dataset   .  :  dataset    .
    '          dataset      , ,      RsRefresh.
    Public Function RsUpdate(Optional ByVal MakeRefresh As Boolean = False) As Boolean
        Try
            If objDataSet.HasChanges Then
                objDataAdapter.Update(objDataSet, "Recordset")
                objDataSet.AcceptChanges()
            End If
            ' refresh      
            If MakeRefresh Then RsRefresh()

            Return True

        Catch e As Exception
            _ErrorMsg$ = "       " & vbCrLf & vbCrLf & e.Message
            RaiseEvent OnDataError(_ErrorMsg)
            Return False
        End Try
    End Function
    '-------------------------------------------------------------------
    '      dataset.  :  dataset    .
    '          dataset      , ,      RsRefresh.
    Public Function RsCancelUpdate(Optional ByVal MakeRefresh As Boolean = False) As Boolean
        Try
            If objDataSet.HasChanges Then
                objDataSet.RejectChanges()
            End If
            ' refresh      
            If MakeRefresh Then RsRefresh()

            Return True

        Catch e As Exception
            _ErrorMsg$ = "      " & vbCrLf & vbCrLf & e.Message
            RaiseEvent OnDataError(_ErrorMsg)
            Return False
        End Try

    End Function
    '--------------------------------------------------
    '       .        manual Increment Primary Key      .
    '      objDataView. 
    Public Function RsGetMaxValue(ByVal strFieldName$) As Long

        If objDataView.Count = 0 Then Return 0

        Dim tempView As DataView
        Try
            tempView = New DataView(objDataSet.Tables(0))
            tempView.Sort = strFieldName
            Return tempView(tempView.Count - 1).Item(strFieldName)

        Catch e As Exception
            _ErrorMsg$ = "          " & strFieldName & vbCrLf & vbCrLf & e.Message
            RaiseEvent OnDataError(_ErrorMsg)
            Return -1
        Finally
            tempView.Dispose()
        End Try

    End Function
    '---------------------------------------------------------------------------
    '     .
    Public Function RsFindDuplicates(ByVal FieldName$) As Object()

        If objDataView.Count = 0 Then Return Nothing

        Dim DoubleValues() As Object
        Dim tempView As DataView
        Dim i%, j%, k%, cntRecs%
        Dim swFoundAlready As Boolean
        Dim itemSearchValue As Object, itemValue As Object

        Try
            tempView = New DataView(objDataSet.Tables(0))
            cntRecs = tempView.Count : k = -1
            For i = 0 To cntRecs - 1
                itemSearchValue = tempView(i)(FieldName)
                If Not (itemSearchValue Is DBNull.Value) Then
                    '        .
                    swFoundAlready = False
                    If k > -1 Then
                        If Array.IndexOf(DoubleValues, itemSearchValue) >= 0 Then swFoundAlready = True
                    End If
                    '        .
                    If Not swFoundAlready Then
                        For j = 0 To cntRecs - 1
                            If i <> j Then
                                itemValue = tempView(j)(FieldName)
                                If Not (itemValue Is DBNull.Value) Then
                                    If itemValue = itemSearchValue Then
                                        '        .
                                        swFoundAlready = False
                                        If k > -1 Then
                                            If Array.IndexOf(DoubleValues, itemSearchValue) >= 0 Then swFoundAlready = True
                                        End If
                                        If Not swFoundAlready Then
                                            k += 1
                                            ReDim Preserve DoubleValues(k)
                                            DoubleValues(k) = itemSearchValue
                                        End If
                                    End If
                                End If
                            End If
                        Next
                    End If
                End If
            Next
            If k > -1 Then Return DoubleValues Else Return Nothing

        Catch e As Exception
            _ErrorMsg$ = "         : " & FieldName & vbCrLf & vbCrLf & e.Message
            RaiseEvent OnDataError(_ErrorMsg)
            Return Nothing
        Finally
            tempView.Dispose()
        End Try

    End Function
    '--------------------------------------------------
    '---------------------------------------------------------------------------
    '        (       .
    ' -    -  . .. "","","","".
    Public Function RsFind(ByVal ParamArray strSearchFieldsAndValues()) As Long

        Dim i% = 0, k% = -1, j%, n%
        Dim strArgument, SearchField()
        Dim SearchValue() As Object
        Dim m_found As Boolean
        Dim objTempView As DataView

        Try
            ' parse       .
            For Each strArgument In strSearchFieldsAndValues
                i += 1
                If (i Mod 2) <> 0 Then
                    '.
                    k += 1
                    ReDim Preserve SearchField(k)
                    SearchField(k) = strArgument
                Else
                    ' .
                    ReDim Preserve SearchValue(k)
                    SearchValue(k) = strArgument
                End If
            Next

            '    .
            Dim synq As Boolean, Entered As Boolean, pos%
            '   dataview 
            objTempView = New DataView(objDataView.Table)
            objTempView.RowFilter = objDataView.RowFilter
            objTempView.Sort = objDataView.Sort

            '.
            m_found = False
            For j = 0 To objTempView.Count - 1
                pos = j
                synq = True : Entered = False
                '            
                '.
                For i = 0 To k
                    If Not (objTempView(pos)(SearchField(i)) Is DBNull.Value) Then
                        Entered = True
                        If (objTempView(pos)(SearchField(i))).GetType.ToString = "System.String" Then
                            '     string.
                            synq = synq And CompareString(CStr((objTempView(pos)(SearchField(i)))), CStr(SearchValue(i)))
                        Else
                            synq = synq And objTempView(pos)(SearchField(i)) = SearchValue(i)
                        End If
                    Else
                        synq = False : Exit For
                    End If
                Next

                ' ,   True      .
                If synq And Entered Then
                    m_found = True
                    Exit For
                End If
                '    (row)  objDataView (j+=1)
            Next

            Return (IIf(m_found, pos, -1))

        Catch e As Exception
            _ErrorMsg$ = "    ." & vbCrLf & vbCrLf & e.Message
            RaiseEvent OnDataError(_ErrorMsg)
            Return -1
        Finally
            objTempView.Dispose()
        End Try

    End Function
    '--------------------------------------------------
    '    objDataView.    .. " ASC", "ONOMA DESC"
    Public Function RsSort(ByVal ParamArray strKeyFields$()) As Boolean
        Dim i%
        Dim keyField$ = "", sortField$ = ""

        Try
            '             ASC  DESC. 
            For Each keyField In strKeyFields
                sortField = IIf(sortField = "", keyField, sortField & "," & keyField)
            Next
            '. 
            If sortField.Trim.Length > 0 Then
                objDataView.Sort = sortField
                _SortText = sortField
            End If

            Return True
        Catch e As Exception
            _ErrorMsg$ = "     " & vbCrLf & vbCrLf & e.Message
            RaiseEvent OnDataError(_ErrorMsg)
            Return False
        End Try

    End Function
    '--------------------------------------------------
    '   objDataView.   .. " > 1980"  .. " LIKE '%'"
    Public Function RsFilter(ByVal strFilter$) As Boolean

        Try
            objDataView.RowFilter = strFilter
            _FilterText = strFilter
            Return True

        Catch e As Exception
            _ErrorMsg$ = "     " & vbCrLf & vbCrLf & e.Message
            RaiseEvent OnDataError(_ErrorMsg)
            Return False
        End Try

    End Function
    '--------------------------------------------------
    '    objDataView.   DataRowView . :     DataRowView,              EndEdit  DataRowView        .
    Public Function RsAddNewRow() As DataRowView

        Try
            Return objDataView.AddNew

        Catch e As Exception
            _ErrorMsg$ = "     " & vbCrLf & vbCrLf & e.Message
            RaiseEvent OnDataError(_ErrorMsg)
            Return Nothing
        End Try

    End Function
    '--------------------------------------------------
    '     objDataView.   DataRowView . :     DataRowView,              EndEdit  DataRowView        .
    Public Function RsGetRow(ByVal indexRow%) As DataRowView

        Try
            Return objDataView.Item(indexRow)

        Catch e As Exception
            _ErrorMsg$ = "       index " & indexRow & vbCrLf & vbCrLf & e.Message
            RaiseEvent OnDataError(_ErrorMsg)
            Return Nothing
        End Try

    End Function
    '--------------------------------------------------
    '      index  objDataView.
    Public Function RsDeleteRow(ByVal index%) As Boolean

        Try
            objDataView.Delete(index)
            Return True

        Catch e As Exception
            _ErrorMsg$ = "      " & vbCrLf & vbCrLf & e.Message
            RaiseEvent OnDataError(_ErrorMsg)
            Return False
        End Try

    End Function
    '--------------------------------------------------
    '--------------------------------------------------
    '  , ,   .   
    Public Function ExecuteCommand(ByVal strCommand$, ByVal strConnectionString$) As Integer

        Dim objConn As New OleDbConnection()
        Dim cmd As OleDbCommand

        Try
            objConn.ConnectionString = strConnectionString
            objConn.Open()
            cmd = New OleDbCommand(strCommand, objConn)
            Return cmd.ExecuteNonQuery

        Catch e As Exception
            _ErrorMsg$ = "     ." & vbCrLf & vbCrLf & e.Message
            RaiseEvent OnDataError(_ErrorMsg)
            Return 0
        Finally
            cmd.Dispose() : objConn.Dispose()
        End Try

    End Function
    '--------------------------------------------------
    'Overloaded .    .
    Public Function ExecuteCommand(ByVal strCommand$) As Integer

        Dim cmd As OleDbCommand
        Try
            If Not (objConnection Is Nothing) Then
                If objConnection.State = ConnectionState.Closed Then objConnection.Open()
                cmd = New OleDbCommand(strCommand, objConnection)
                Return cmd.ExecuteNonQuery
            End If

        Catch e As Exception
            _ErrorMsg$ = "     ." & vbCrLf & vbCrLf & e.Message
            RaiseEvent OnDataError(_ErrorMsg)
            Return 0
        Finally
            cmd.Dispose()
        End Try

    End Function
    '--------------------------------------------------
    'E  DataReader   forward-read-only      .   
    Public Function ExecuteReader(ByVal strSQL$, ByVal strConnectionString$) As OleDbDataReader

        Dim objConn As New OleDbConnection()
        Dim cmd As OleDbCommand
        Try
            objConn.ConnectionString = strConnectionString
            objConn.Open()
            cmd = New OleDbCommand(strSQL, objConn)
            Return cmd.ExecuteReader
            Return Nothing

        Catch e As Exception
            _ErrorMsg$ = "     DataReader" & vbCrLf & vbCrLf & e.Message
            RaiseEvent OnDataError(_ErrorMsg)
            Return Nothing
        Finally
            cmd.Dispose()
        End Try

    End Function
    '--------------------------------------------------
    'Overloaded .    .
    Public Function ExecuteReader(ByVal strSQL$) As OleDbDataReader

        Dim cmd As OleDbCommand
        Try
            cmd = New OleDbCommand(strSQL, objConnection)
            Return cmd.ExecuteReader
            Return Nothing

        Catch e As Exception
            _ErrorMsg$ = "     DataReader" & vbCrLf & vbCrLf & e.Message
            RaiseEvent OnDataError(_ErrorMsg)
            Return Nothing
        Finally
            cmd.Dispose()
        End Try

    End Function
    '--------------------------------------------------
    'E      .     1   1   , ,   .   
    Public Function ExecuteScalar(ByVal strAggregateSQL$, ByVal strConnectionString$) As Object

        Dim objConn As New OleDbConnection()
        Dim cmd As OleDbCommand
        Try
            objConn.ConnectionString = strConnectionString
            objConn.Open()
            cmd = New OleDbCommand(strAggregateSQL, objConnection)
            Return cmd.ExecuteScalar

        Catch e As Exception
            _ErrorMsg$ = "     " & vbCrLf & vbCrLf & e.Message
            RaiseEvent OnDataError(_ErrorMsg)
            Return Nothing
        Finally
            cmd.Dispose() : objConn.Dispose()
        End Try

    End Function
    '--------------------------------------------------
    'Overloaded . E      .     1   1   , ,   .   
    Public Function ExecuteScalar(ByVal strAggregateSQL$) As Object

        Dim cmd As OleDbCommand
        Try
            If Not (objConnection Is Nothing) Then
                If objConnection.State = ConnectionState.Closed Then objConnection.Open()
                cmd = New OleDbCommand(strAggregateSQL, objConnection)
                Return cmd.ExecuteScalar
            Else
                Return Nothing
            End If

        Catch e As Exception
            _ErrorMsg$ = "     " & vbCrLf & vbCrLf & e.Message
            RaiseEvent OnDataError(_ErrorMsg)
            Return Nothing
        Finally
            cmd.Dispose()
        End Try

    End Function
    '--------------------------------------------------
    '----------------------------------------------------------------------------------
    ' PRIVATE 
    '----------------------------------------------------------------------------------
    '        ,  objDataView
    Private Function MakeDataView() As Boolean

        Try
            objDataView = New DataView()
            objDataView = objDataSet.Tables("Recordset").DefaultView

            '    DataView.
            objDataView.AllowNew = AllowAdd
            objDataView.AllowEdit = AllowEdit
            objDataView.AllowDelete = AllowDelete
            Return True

        Catch e As Exception
            _ErrorMsg = "     DataView." & vbCrLf & vbCrLf & e.Message
            RaiseEvent OnDataError(_ErrorMsg)
            Return False
        End Try

    End Function
    '----------------------------------------------------------------------------------
    '  string     FindTypeForString. ,  ,  . .
    Private Function CompareString(ByVal strFieldValue$, ByVal strValue$) As Boolean

        Dim str1$, str2$

        Try
            If _MatchCaseForString Then
                str1 = strFieldValue : str2 = strValue
            Else
                str1 = strFieldValue.ToUpper : str2 = strValue.ToUpper
            End If

            Select Case _FindTypeForString
                Case Is = FindTypeForStringEnum.Equal
                    Return (str1 = str2)
                Case Is = FindTypeForStringEnum.StartsWith
                    Return (str1.StartsWith(str2))
                Case Is = FindTypeForStringEnum.EndsWith
                    Return (str1.EndsWith(str2))
                Case Is = FindTypeForStringEnum.Contains
                    Return (IIf(InStr(1, str1, str2) = 0, False, True))
            End Select
        Catch
            Return False
        End Try

    End Function
    '--------------------------------------------------
    ' . 
    Private Sub ReleaseDataObjects()

        On Error Resume Next
        objDataView.Dispose()
        objDataAdapter.SelectCommand.Dispose()
        objCommBuilder.Dispose()
        objDataAdapter.Dispose()
        objDataSet.Dispose()
        objConnection.Dispose()

    End Sub
    '--------------------------------------------------
    '
    Protected Overrides Sub Finalize()
        MyBase.Finalize()

        ReleaseDataObjects()

    End Sub
    '--------------------------------------------------
End Class
